import "reflect-metadata";
import { Class, CustomPropertyDecorator, DecoratorOption, DecoratorTargetType, NativeParameterDecorator } from "./types";
export declare function decorateParameter(callback: ((target: Class, name: string, index: number) => any), option?: DecoratorOption): ParameterDecorator;
export declare function decorateParameter(data: any, option?: DecoratorOption): ParameterDecorator;
export declare function decorateMethod(callback: ((target: Class, name: string) => any), option?: DecoratorOption): MethodDecorator;
export declare function decorateMethod(data: any, option?: DecoratorOption): MethodDecorator;
export declare function decorateProperty(callback: ((target: Class, name: string, index?: any) => any), option?: DecoratorOption): CustomPropertyDecorator;
export declare function decorateProperty(data: any, option?: DecoratorOption): CustomPropertyDecorator;
export declare function decorateClass(callback: ((target: Class) => any), option?: DecoratorOption): ClassDecorator;
export declare function decorateClass(data: any, option?: DecoratorOption): ClassDecorator;
export declare function decorate(data: any | ((...args: any[]) => any), targetTypes?: DecoratorTargetType[], option?: Partial<DecoratorOption>): (...args: any[]) => void;
export declare function mergeDecorator(...fn: (ClassDecorator | PropertyDecorator | NativeParameterDecorator | MethodDecorator)[]): (...args: any[]) => void;
export declare function noop(): (...args: any[]) => void;
export declare function ignore(): (...args: any[]) => void;
export declare function type(type: string | string[] | Class | Class[], info?: string): (...args: any[]) => void;
export declare function array(type: Class | string): (...args: any[]) => void;
export declare function parameterProperties(): ClassDecorator;
export declare namespace generic {
    function template(...templates: string[]): ClassDecorator;
    function type(...types: (Class | Class[])[]): ClassDecorator;
    /**
     * Create generic class dynamically
     * @param parent Super class that the class inherited from
     * @param params List of generic type parameters
     */
    function create<T extends Class>(parent: T, ...params: Class[]): T;
}
