"use strict";
/* ---------------------------------------------------------------- */
/* --------------------------- HELPERS ---------------------------- */
/* ---------------------------------------------------------------- */
Object.defineProperty(exports, "__esModule", { value: true });
function useCache(cache, fn, getKey) {
    return (...args) => {
        const key = getKey(...args);
        const result = cache.get(key);
        if (!!result)
            return result;
        else {
            const newResult = fn(...args);
            cache.set(key, newResult);
            return newResult;
        }
    };
}
exports.useCache = useCache;
var metadata;
(function (metadata) {
    function isConstructor(value) {
        return ("" + value).indexOf("class") == 0;
    }
    metadata.isConstructor = isConstructor;
    function isCustomClass(type) {
        switch (type) {
            case Boolean:
            case String:
            case Array:
            case Number:
            case Object:
            case Date:
                return false;
            default:
                return true;
        }
    }
    metadata.isCustomClass = isCustomClass;
})(metadata || (metadata = {}));
exports.metadata = metadata;
