import { ClassReflection, ParameterPropertyReflection, Reflection, TypedReflection, Class } from "./types";
declare type ReflectionVisitor = (value: TypedReflection, ctx: TraverseContext) => TypedReflection | undefined;
interface TraverseContext {
    target: Class;
    parent: Reflection;
    visitor: ReflectionVisitor;
}
declare function createVisitors(...visitors: ReflectionVisitor[]): ReflectionVisitor;
declare function purifyTraversal(meta: any, ctx: TraverseContext): import("./types").ParameterReflection | import("./types").PropertyReflection | import("./types").MethodReflection | ClassReflection | import("./types").ConstructorReflection | ParameterPropertyReflection | undefined;
declare function extendsClass(meta: ClassReflection): ClassReflection;
declare namespace visitors {
    function addSuperclassMeta(meta: TypedReflection, ctx: TraverseContext): TypedReflection;
    function addsDesignTypes(meta: TypedReflection, ctx: TraverseContext): TypedReflection;
    function addsDecorators(meta: TypedReflection, ctx: TraverseContext): TypedReflection;
    function addsTypeOverridden(meta: TypedReflection, ctx: TraverseContext): TypedReflection;
    function addsGenericOverridden(meta: TypedReflection, ctx: TraverseContext): TypedReflection;
    function addsTypeClassification(meta: TypedReflection, ctx: TraverseContext): TypedReflection | undefined;
    function addsParameterProperties(meta: TypedReflection, ctx: TraverseContext): TypedReflection | undefined;
    function removeIgnored(meta: TypedReflection, ctx: TraverseContext): TypedReflection | undefined;
}
export { visitors, purifyTraversal, createVisitors, extendsClass };
